Codeforces 1459 Row GCD(GCD,结论)

2024-04-15 23:18
文章标签 codeforces row 结论 gcd 1459

本文主要是介绍Codeforces 1459 Row GCD(GCD,结论),希望对大家解决编程问题提供一定的参考价值,需要的开发者们随着小编来一起学习吧!

You are given two positive integer sequences 𝑎1,…,𝑎𝑛 and 𝑏1,…,𝑏𝑚. For each 𝑗=1,…,𝑚 find the greatest common divisor of 𝑎1+𝑏𝑗,…,𝑎𝑛+𝑏𝑗.

Input
The first line contains two integers 𝑛 and 𝑚 (1≤𝑛,𝑚≤2⋅105).

The second line contains 𝑛 integers 𝑎1,…,𝑎𝑛 (1≤𝑎𝑖≤1018).

The third line contains 𝑚 integers 𝑏1,…,𝑏𝑚 (1≤𝑏𝑗≤1018).

Output
Print 𝑚 integers. The 𝑗-th of them should be equal to GCD(𝑎1+𝑏𝑗,…,𝑎𝑛+𝑏𝑗).

Example
inputCopy
4 4
1 25 121 169
1 2 7 23
outputCopy
2 3 8 24

题意:
对于 1 ≤ j ≤ m 1≤j≤m 1jm,求 g c d ( a [ 1 ] + b [ j ] , a [ 2 ] + b [ j ] , a [ 3 ] + b [ j ] . . . ) gcd(a[1]+b[j],a[2]+b[j],a[3]+b[j]...) gcd(a[1]+b[j],a[2]+b[j],a[3]+b[j]...)的值

思路:
由辗转相除法: g c d ( a , b ) = g c d ( a − b , b ) gcd(a,b)=gcd(a-b,b) gcd(a,b)=gcd(ab,b)
所以 g c d ( a , b , c , d , e , f , . . . , z ) = g c d ( a − z , b − z , c − z , d − z , . . . , z ) gcd(a,b,c,d,e,f,...,z)=gcd(a-z,b-z,c-z,d-z,...,z) gcd(a,b,c,d,e,f,...,z)=gcd(az,bz,cz,dz,...,z)
由此原式中每个数多加的 b [ j ] b[j] b[j]可以忽略,只有最后一个数要考虑加上 b [ n ] b[n] b[n],预处理出差分值的 g c d gcd gcd,再与 a [ n ] + b [ j ] a[n]+b[j] a[n]+b[j] g c d gcd gcd运算即可。

ps:注意负数

#include <cstdio>
#include <cstring>
#include <algorithm>
#include <vector>
#include <queue>
#include <map>
using namespace std;
typedef long long ll;
const int maxn = 2e5 + 7;
ll a[maxn],b[maxn];ll gcd(ll n,ll m) {return m == 0 ? n : gcd(m,n % m);
}int main() {int n,m;scanf("%d%d",&n,&m);for(int i = 1;i <= n;i++) {scanf("%lld",&a[i]);}for(int i = 1;i <= m;i++) {scanf("%lld",&b[i]);}if(n == 1) {for(int i = 1;i <= m;i++) {printf("%lld ",a[1] + b[i]);}return 0;}ll now = 0;for(int i = 2;i <= n;i++) {if(!now) now = abs(a[i] - a[i - 1]);else now = gcd(now,abs(a[i] - a[i - 1]));}for(int j = 1;j <= m;j++) {ll ans = gcd(now,a[n] + b[j]);printf("%lld ",ans);}return 0;
}

这篇关于Codeforces 1459 Row GCD(GCD,结论)的文章就介绍到这儿,希望我们推荐的文章对编程师们有所帮助!



http://www.chinasem.cn/article/907205

相关文章

Codeforces Round #240 (Div. 2) E分治算法探究1

Codeforces Round #240 (Div. 2) E  http://codeforces.com/contest/415/problem/E 2^n个数,每次操作将其分成2^q份,对于每一份内部的数进行翻转(逆序),每次操作完后输出操作后新序列的逆序对数。 图一:  划分子问题。 图二: 分而治之,=>  合并 。 图三: 回溯:

Codeforces Round #261 (Div. 2)小记

A  XX注意最后输出满足条件,我也不知道为什么写的这么长。 #define X first#define Y secondvector<pair<int , int> > a ;int can(pair<int , int> c){return -1000 <= c.X && c.X <= 1000&& -1000 <= c.Y && c.Y <= 1000 ;}int m

Codeforces Beta Round #47 C凸包 (最终写法)

题意慢慢看。 typedef long long LL ;int cmp(double x){if(fabs(x) < 1e-8) return 0 ;return x > 0 ? 1 : -1 ;}struct point{double x , y ;point(){}point(double _x , double _y):x(_x) , y(_y){}point op

Codeforces Round #113 (Div. 2) B 判断多边形是否在凸包内

题目点击打开链接 凸多边形A, 多边形B, 判断B是否严格在A内。  注意AB有重点 。  将A,B上的点合在一起求凸包,如果凸包上的点是B的某个点,则B肯定不在A内。 或者说B上的某点在凸包的边上则也说明B不严格在A里面。 这个处理有个巧妙的方法,只需在求凸包的时候, <=  改成< 也就是说凸包一条边上的所有点都重复点都记录在凸包里面了。 另外不能去重点。 int

Codeforces 482B 线段树

求是否存在这样的n个数; m次操作,每次操作就是三个数 l ,r,val          a[l] & a[l+1] &......&a[r] = val 就是区间l---r上的与的值为val 。 也就是意味着区间[L , R] 每个数要执行 | val 操作  最后判断  a[l] & a[l+1] &......&a[r] 是否= val import ja

INDEX+SMALL+IF+ROW函数组合使用解…

很多人在Excel中用函数公式做查询的时候,都必然会遇到的一个大问题,那就是一对多的查找/查询公式应该怎么写?大多数人都是从VLOOKUP、INDEX+MATCH中入门的,纵然你把全部的多条件查找方法都学会了而且运用娴熟,如VLOOKUP和&、SUMPRODUCT、LOOKUP(1,0/....,但仍然只能对这种一对多的查询望洋兴叹。   这里讲的INDEX+SMALL+IF+ROW的函数组合,

Codeforces Round 971 (Div. 4) (A~G1)

A、B题太简单,不做解释 C 对于 x y 两个方向,每一个方向至少需要 x / k 向上取整的步数,取最大值。 由于 x 方向先移动,假如 x 方向需要的步数多于 y 方向的步数,那么最后 y 方向的那一步就不需要了,答案减 1 代码 #include <iostream>#include <algorithm>#include <vector>#include <string>

Codeforces#295(Div.2)A、B(模拟+BFS)

解题报告链接:点击打开链接 C. 题目链接:点击打开链接 解题思路: 对于给定的字符串,取出现次数最多的字母(可以同时有多个)。由这些字母组成长度为n的字符串,求有多少种组合。最后用数学知识即可。 完整代码: #include <algorithm>#include <iostream>#include <cstring>#include <climits>

Codeforces Round #281 (Div. 2)A(构造+暴力模拟)

题目链接:http://codeforces.com/problemset/problem/493/A 解题思路: 暴力的判断,分三种情况去判断即可。注意如果之前已经被罚下场后,那么在后面的罚下情况不应该算在输出结果内。 完整代码: #include <algorithm>#include <iostream>#include <cstring>#include <co

Codeforces Round #182 (Div. 2)A(水题)

题目链接:http://codeforces.com/contest/302/problem/A 解题思路: 只要通过重新排列使区间内和为0即是1,否则是0. 完整代码: #include <algorithm>#include <iostream>#include <cstring>#include <complex>#include <cstdio>#inc